Sketcher๏ƒ

Sketcher commands are used to define the entities, such as the geometry, constraints, and dimensions, to create a sketch and to store the values and attributes associated with a particular sketch.

Create constrained sketches๏ƒ

class SketchModel(name, description='', stefanBoltzmann=None, absoluteZero=None, waveFormulation=abaqusConstants.NOT_SET, modelType=abaqusConstants.STANDARD_EXPLICIT, universalGas=None, copyConstraints=1, copyConnectors=1, copyInteractions=1)[source]๏ƒ

Bases: ModelBase

Abaqus creates a Model object named Model-1 when a session is started.

Note

This object can be accessed by:

mdb.models[name]

This method creates a Model object.

Note

This function can be accessed by:

mdb.Model
Parameters:
  • name (str) โ€“ A String specifying the repository key.

  • description (str, default: '') โ€“ A String specifying the purpose and contents of the Model object. The default value is an empty string.

  • stefanBoltzmann (Optional[float], default: None) โ€“ None or a Float specifying the Stefan-Boltzmann constant. The default value is None.

  • absoluteZero (Optional[float], default: None) โ€“ None or a Float specifying the absolute zero constant. The default value is None.

  • waveFormulation (Literal[SCATTERED, NOT_SET, TOTAL], default: NOT_SET) โ€“ A SymbolicConstant specifying the type of incident wave formulation to be used in acoustic problems. Possible values are NOT_SET, SCATTERED, and TOTAL. The default value is NOT_SET.

  • modelType (Literal[STANDARD_EXPLICIT, ELECTROMAGNETIC], default: STANDARD_EXPLICIT) โ€“ A SymbolicConstant specifying the analysis model type. Possible values are STANDARD_EXPLICIT and ELECTROMAGNETIC. The default is STANDARD_EXPLICIT.

  • universalGas (Optional[float], default: None) โ€“ None or a Float specifying the universal gas constant. The default value is None.

  • copyConstraints (Union[AbaqusBoolean, bool], default: 1) โ€“ A boolean specifying whether to copy the constraints created in the model to the model that instances this model. The default value is ON.

  • copyConnectors (Union[AbaqusBoolean, bool], default: 1) โ€“ A boolean specifying whether to copy the connectors created in the model to the model that instances this model. The default value is ON.

  • copyInteractions (Union[AbaqusBoolean, bool], default: 1) โ€“ A boolean specifying whether to copy the interactions created in the model to the model that instances this model. The default value is ON.

Returns:

A Model object.

Return type:

Model

Public Data Attributes:

Inherited from ModelBase

name

A String specifying the repository key.

stefanBoltzmann

None or a Float specifying the Stefan-Boltzmann constant.

absoluteZero

None or a Float specifying the absolute zero constant.

waveFormulation

A SymbolicConstant specifying the type of incident wave formulation to be used in acoustic problems.

universalGas

None or a Float specifying the universal gas constant.

noPartsInputFile

A Boolean specifying whether an input file should be written without parts and assemblies.

endRestartStep

A Boolean specifying that the step specified by restartStep should be terminated at the increment specified by restartIncrement.

shellToSolid

A Boolean specifying that a shell global model drives a solid submodel.

lastChangedCount

A Float specifying the time stamp that indicates when the model was last changed.

description

A String specifying the purpose and contents of the Model object.

restartJob

A String specifying the name of the job that generated the restart data.

restartStep

A String specifying the name of the step where the restart analysis will start.

globalJob

A String specifying the name of the job that generated the results for the global model.

copyConstraints

A boolean specifying the status of constraints created in a model, in the model which instances this model.

copyConnectors

A boolean specifying the status of connectors created in a model, in the model which instances this model.

copyInteractions

A boolean specifying the status of interactions created in a model, in the model which instances this model.

keywordBlock

A KeywordBlock object.

rootAssembly

An Assembly object.

amplitudes

A repository of Amplitude objects.

profiles

A repository of Profile objects.

boundaryConditions

A repository of BoundaryCondition objects.

constraints

A repository of ConstrainedSketchConstraint objects.

analyticalFields

A repository of AnalyticalField objects.

discreteFields

A repository of DiscreteField objects.

predefinedFields

A repository of PredefinedField objects.

interactions

A repository of Interaction objects.

interactionProperties

A repository of InteractionProperty objects.

contactControls

A repository of ContactControl objects.

contactInitializations

A repository of ContactInitialization objects.

contactStabilizations

A repository of ContactStabilization objects.

linkedInstances

A tuple of tuples of Strings specifying the linked child PartInstance name in the current model to the corresponding parent PartInstance name in a different model.

linkedParts

A tuple of tuples of Strings specifying the linked child Part name in the current model to the corresponding parent Part name in a different model.

loads

A repository of Load objects.

materials

A repository of Material objects.

calibrations

A repository of Calibration objects.

sections

A repository of Section objects.

remeshingRules

A repository of RemeshingRule objects.

sketches

A repository of ConstrainedSketch objects.

parts

A repository of Part objects.

steps

A repository of Step objects.

featureOptions

A FeatureOptions object.

adaptiveMeshConstraints

A repository of AdaptiveMeshConstraint objects.

adaptiveMeshControls

A repository of AdaptiveMeshControl objects.

timePoints

A repository of TimePoint objects.

filters

A repository of Filter objects.

integratedOutputSections

A repository of IntegratedOutputSection objects.

fieldOutputRequests

A repository of FieldOutputRequest objects.

historyOutputRequests

A repository of HistoryOutputRequest objects.

optimizationTasks

A repository of OptimizationTask objects.

tableCollections

A repository of TableCollection objects.

eventSeriesTypes

A repository of EventSeriesType objects.

eventSeriesDatas

A repository of EventSeriesData objects.

restartIncrement

An Int specifying the increment, interval, iteration or cycle where the restart analysis will start.

Public Methods:

ConstrainedSketch(name,ย sheetSize[,ย ...])

This method creates a ConstrainedSketch object.

Inherited from ModelBase

__init__(name[,ย description,ย ...])

This method creates a Model object.

ModelFromInputFile(name,ย inputFileName)

This method creates a Model object by reading the keywords in an input file and creating the corresponding Abaqus/CAE objects.

ModelFromOdbFile(name,ย odbFileName)

This method creates a Model object by reading an output database and creating any corresponding Abaqus/CAE objects.

ModelFromNastranFile(modelName,ย inputFileName)

This method creates a Model object by reading the keywords in a Nastran bulk data file or Nastran input file and creating any corresponding Abaqus/CAE objects.

setValues([description,ย noPartsInputFile,ย ...])

This method modifies the Model object.


Member Details:

ConstrainedSketch(name, sheetSize, gridSpacing=None, transform=())[source]๏ƒ

This method creates a ConstrainedSketch object. If the sketch cannot be created, the method returns None.

Note

This function can be accessed by:

mdb.models[name].ConstrainedSketch
Parameters:
  • name (str) โ€“ A String specifying the repository key.

  • sheetSize (float) โ€“ A Float specifying the sheet size.

  • gridSpacing (Optional[float], default: None) โ€“ A Float specifying the spacing between gridlines. Possible values are Floats > 0. The default value is approximately 2 percent of sheetSize.

  • transform (tuple, default: ()) โ€“ A sequence of sequences of Floats specifying the three-dimensional orientation of the sketch. The sequence is a 3 x 4 transformation matrix specifying the axis of rotation and the translation vector. Possible values are any Floats.The default value for the axis of rotation is the identity matrix`(1.0, 0.0, 0.0), (0.0, 1.0, 0.0), (0.0, 0.0, 1.0)`The default value for the translation vector is`(0.0, 0.0, 0.0)`The default values position the sketch on the X - Y plane centered at the origin.

Returns:

sketch โ€“ A ConstrainedSketch object.

Return type:

ConstrainedSketch

Other Classes๏ƒ

class ConstrainedSketch(name: str, sheetSize: float, gridSpacing: float | None = None, transform: tuple = ())[source]๏ƒ
class ConstrainedSketch(name: str, objectToCopy: ConstrainedSketch)

Bases: ConstrainedSketchConstraintModel, ConstrainedSketchDimensionModel, ConstrainedSketchGeometryModel, ConstrainedSketchParameterModel, ConstrainedSketchVertexModel

Member Details:

ConstrainedSketchFromGeometryFile(name, geometryFile)[source]๏ƒ

This method creates a ConstrainedSketch object and places it in the sketches repository.

Note

This function can be accessed by:

mdb.models[name].ConstrainedSketchFromGeometryFile
Parameters:
  • name (str) โ€“ A String specifying the repository key.

  • geometryFile (AcisFile) โ€“ An AcisFile object specifying a file containing geometry. The geometry in the file is converted to two-dimensional sketch geometry in the X - Y plane.

Returns:

sketch โ€“ A ConstrainedSketch object

Return type:

ConstrainedSketch

assignCenterOfTwist(point)[source]๏ƒ

This method indicates the isolated point that will be used as the center of twist when an extruded feature is created with twist.

Parameters:

point (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying an isolated point that indicates the center of twist for extruded features that use a twist angle.

assignCenterline(line)[source]๏ƒ

This method indicates the construction line that will be used as a centerline for revolved features.

Parameters:

line (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying a construction line that indicates the centerline of revolved features.

autoDimension(objectList)[source]๏ƒ

This method applies dimensions to the selected ConstrainedSketchGeometry objects in an effort to make the ConstrainedSketch well defined.

Parameters:

objectList (tuple) โ€“ A sequence specifying the ConstrainedSketchGeometry objects to dimension.

autoTrimCurve(curve1, point1, parameter1)[source]๏ƒ

This method automatically trims a selected ConstrainedSketchGeometry object at the specified location. If the object does not intersect other ConstrainedSketchGeometry objects, the entire selected object will be deleted.

Parameters:
  • curve1 (str) โ€“ The ConstrainedSketchGeometry object to be trimmed.

  • point1 (tuple[float, float]) โ€“ A pair of Floats specifying the location on ConstrainedSketchGeometry where the trimming should be applied. point1 and parameter1 are mutually exclusive.

  • parameter1 (float) โ€“ A Float specifying the parameter location on the ConstrainedSketchGeometry where the trimming should be applied. point1 and parameter1 are mutually exclusive.

breakCurve(curve1, point1, curve2, point2)[source]๏ƒ

This method breaks a specified ConstrainedSketchGeometry object (curve1) using another specified ConstrainedSketchGeometry object (curve2). If the selected ConstrainedSketchGeometry objects intersect, then only curve1 will be broken; curve2 is not affected by the operation. The location for the break is determined by the specified point values.

Parameters:
  • curve1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the object to be broken.

  • point1 (tuple[float, float]) โ€“ A pair of Floats specifying the location on curve1 near where the break should be applied.

  • curve2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying where curve1 should be broken.

  • point2 (tuple[float, float]) โ€“ A pair of Floats specifying the location on curve2 near where curve1 should be broken.

copyMirror(mirrorLine, objectList)[source]๏ƒ

This method creates copies of the given ConstrainedSketchGeometry objects, mirrors them about a selected line, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
  • mirrorLine (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the line about which Abaqus will mirror the sketch.

  • objectList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects specifying the sketch to be copied and mirrored.

copyMove(vector, objectList)[source]๏ƒ

This method creates copies of the given ConstrainedSketchGeometry objects, moves them from their original position, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
  • vector (tuple) โ€“ A sequence of two Floats specifying the translation vector.

  • objectList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects to be copied and moved.

copyRotate(centerPoint, angle, objectList)[source]๏ƒ

This method creates copies of the given ConstrainedSketchGeometry objects, rotates them, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
  • centerPoint (tuple[float, float]) โ€“ A pair of Floats specifying the center of rotation.

  • angle (float) โ€“ A Float specifying the angle of rotation in degrees.

  • objectList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects to be copied and moved.

copyScale(scaleValue, scaleCenter, objectList)[source]๏ƒ

This method creates copies of the given ConstrainedSketchGeometry objects, scales them by the specified value about a selected point, and inserts them into the appropriate repositories of the ConstrainedSketch object.

Parameters:
  • scaleValue (float) โ€“ A Float specifying the value for scaling.

  • scaleCenter (tuple[float, float]) โ€“ A pair of Floats specifying the center of scaling.

  • objectList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects to be copied and scaled.

delete(objectList)[source]๏ƒ

This method deletes the given ConstrainedSketchGeometry, ConstrainedSketchDimension, or ConstrainedSketchConstraint objects.

Parameters:

objectList (tuple) โ€“ A sequence of ConstrainedSketchGeometry, ConstrainedSketchDimension, or ConstrainedSketchConstraint objects to be deleted.

deleteParameter(name)[source]๏ƒ

The command deletes a specified parameter.

Parameters:

name (str) โ€“ A String specifying the name of the parameter to delete.

dragEntity(entity, points)[source]๏ƒ

This method drags a specified ConstrainedSketchGeometry or ConstrainedSketchVertex object to a specific location.

Parameters:
  • entity (str) โ€“ A ConstrainedSketchGeometry or ConstrainedSketchVertex object specifying the object to drag.

  • points (tuple) โ€“ A sequence of sequences of three Floats specifying a sequence of points along which to drag the entity. The order of points in the sequence defines a path that determines the solution.

linearPattern(number1, spacing1, angle1, vertexList=(), geomList=(), number2=1, spacing2=None, angle2=None)[source]๏ƒ

This method copies ConstrainedSketchGeometry objects in a linear pattern along one or two directions. This method also copies any associated dimension or constraint objects that exist between the given objects.

Parameters:
  • number1 (int) โ€“ An Integer specifying the total number of copies, including the original objects, that appear along the first direction in the pattern. Possible values are 1 โ‰ค number1 โ‰ค 1000.

  • spacing1 (float) โ€“ A Float specifying the spacing between copies along the first direction in the pattern. Possible values are 0.0 โ‰ค spacing1 .

  • angle1 (float) โ€“ A Float specifying the angle in degrees of the first direction in the pattern. Possible values are -360.0 โ‰ค angle1 โ‰ค 360.0.

  • vertexList (Sequence[ConstrainedSketchVertex], default: ()) โ€“ A sequence of ConstrainedSketchVertex objects to copy.

  • geomList (Sequence[ConstrainedSketchGeometry], default: ()) โ€“ A sequence of ConstrainedSketchGeometry objects to copy.

  • number2 (int, default: 1) โ€“ An integer specifying the total number of copies, including the original objects, that appear along the second direction in the pattern. Possible values are 1 โ‰ค number2 โ‰ค 1000. The default value is 1. The value of either number1 or number2 must be greater than one.

  • spacing2 (Optional[float], default: None) โ€“ A Float specifying the spacing between copies along the first direction in the pattern. Possible values are 0.0 โ‰ค spacing2. The default value is spacing1.

  • angle2 (Optional[float], default: None) โ€“ A Float specifying the angle in degrees of the first direction in the pattern. Possible values are -360.0 โ‰ค angle2 โ‰ค 360.0. The default value is 90ยฐ beyond the value of angle1.

Return type:

None.

Raises:

AbaqusException โ€“ Number must be greater than 1 for at least one direction

mergeVertices(value, vertexList)[source]๏ƒ

This method merges the ConstrainedSketchVertex objects that lie within the specified distance of each other. If only one ConstrainedSketchVertex object is selected, it will merge all ConstrainedSketchVertex objects that lie within the specified distance of that vertex. If more than one vertex is selected, the search will be restricted to only the selected ConstrainedSketchVertex objects.

Parameters:
move(vector, objectList)[source]๏ƒ

This method translates the given ConstrainedSketchGeometry objects by the given vector.

Parameters:
  • vector (tuple) โ€“ A sequence of two Floats specifying the translation vector.

  • objectList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects specifying the objects to be translated.

offset(distance, objectList, side, filletCorners=0)[source]๏ƒ

This method creates copies of the selected ConstrainedSketchGeometry objects, offsets them by the specified distance in the specified direction, and inserts them into the ConstrainedSketch objectโ€™s appropriate repositories. If connected objects are selected, trim or extend is carried out to complete the offset.

Parameters:
  • distance (float) โ€“ A Float specifying the distance to be offset.

  • objectList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects to be copied and offset.

  • side (Literal[LEFT, RIGHT]) โ€“ A SymbolicConstant specifying which side the offset should occur. Possible values are LEFT and RIGHT.

  • filletCorners (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the corners need to be rounded instead of being extended.

print()[source]๏ƒ

This method prints the following statistics about a sketch:

  • The sketch Id (a positive integer).

  • The number of geometry curves (the number of ConstrainedSketchGeometry objects).

  • The number of dimensions (the number of ConstrainedSketchDimension objects).

  • The number of vertices (the number of ConstrainedSketchVertex objects).

radialPattern(number, totalAngle, centerPoint, vertexList=(), geomList=())[source]๏ƒ

This method copies ConstrainedSketchGeometry objects in a radial pattern about a specified center point.

Parameters:
  • number (int) โ€“ An Int specifying the total number of copies, including the original objects, that appear in the radial pattern. Possible values are 2 โ‰ค number2 โ‰ค 1000.

  • totalAngle (float) โ€“ A Float specifying the total angle in degrees between the first and last instance in the pattern. A positive angle corresponds to a counter-clockwise direction. The values 360ยฐ and -360ยฐ represent a special case where the pattern makes a full circle. In this case, because the copy would overlay the original, the copy is not placed at the last position. Possible values are -360.0 โ‰ค totalAngle โ‰ค 360.0.

  • centerPoint (tuple[float, float]) โ€“ A pair of Floats specifying the center of the radial pattern.

  • vertexList (Sequence[ConstrainedSketchVertex], default: ()) โ€“ A sequence of ConstrainedSketchVertex objects to copy.

  • geomList (Sequence[ConstrainedSketchGeometry], default: ()) โ€“ A sequence of ConstrainedSketchGeometry objects to copy.

rectangle(point1, point2)[source]๏ƒ

This method creates four lines that form a rectangle with diagonal corners defined by the given points and inserts them into the geometry repository of the ConstrainedSketch object.

Parameters:
  • point1 (tuple[float, float]) โ€“ A pair of Floats specifying the first corner of the rectangle.

  • point2 (tuple[float, float]) โ€“ A pair of Floats specifying the second corner of the rectangle.

Returns:

success โ€“ An Int specifying the success or failure of the method. A value of 0 indicates failure

Return type:

int

removeGapsAndOverlaps(tolerance, geomList)[source]๏ƒ

This method removes gaps and overlaps between sketch geometries specified by the user. This method is particularly useful when cleaning up imported sketches.

Parameters:
  • tolerance (str) โ€“ A float value which specifies the largest size of the gap or overlap between entities that is to be removed. Typically this value is small and is used to close gaps and overlaps which may not exist in the originating program but exist in the sketch because of mismatched tolerances between the two programs.

  • geomList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects where the gaps and overlaps are to be removed.

repairShortEdges(geomList, tolerance='')[source]๏ƒ

This method deletes the short edges specified, optionally selecting only those short edges whose lengths are smaller than the specified tolerance and healing the resultant gap in the sketch. This method is particularly useful in conjunction with removeGapsAndOverlap when cleaning up imported sketches.

Parameters:
  • geomList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects where the short edges are to be removed.

  • tolerance (str, default: '') โ€“ A float value that is used to select and delete only those edges specified in geomList whose lengths are smaller than the given value. The default value is -1.0. This value implies that all edges specified in geomList will be removed and the sketch healed to remove gaps left by their removal.

resetView()[source]๏ƒ

This method resets the view to be perpendicular to the sketching plane.

retrieveSketch(sketch)[source]๏ƒ

This method copies all ConstrainedSketchGeometry, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects from the specified ConstrainedSketch object. The new objects are added to the existing objects (if any). The objects in the specified ConstrainedSketch object are not modified by the retrieve operation.

Parameters:

sketch (ConstrainedSketch) โ€“ A ConstrainedSketch object specifying the object from which to copy.

rotate(centerPoint, angle, objectList)[source]๏ƒ

This method rotates the given ConstrainedSketchGeometry objects by the given angle and about the given point.

Parameters:
  • centerPoint (tuple[float, float]) โ€“ A pair of Floats specifying the center of rotation.

  • angle (float) โ€“ A Float specifying the angle of rotation in degrees.

  • objectList (tuple) โ€“ A sequence of ConstrainedSketchGeometry specifying the objects to be rotated.

scale(scaleValue, scaleCenter, objectList)[source]๏ƒ

This method scales the given ConstrainedSketchGeometry objects by the given scale factor and about the given point.

Parameters:
  • scaleValue (float) โ€“ A Float specifying the value of scale.

  • scaleCenter (tuple[float, float]) โ€“ A pair of Floats specifying the center of scale.

  • objectList (Sequence[ConstrainedSketchGeometry]) โ€“ A sequence of ConstrainedSketchGeometry objects specifying the objects to be scaled.

setPrimaryObject(option)[source]๏ƒ

This method makes the ConstrainedSketch object the primary object in the current viewport. The sketch remains the primary object in the current viewport until an unsetPrimaryobject command is issued.

Parameters:

option (Literal[STANDALONE, SUPERIMPOSE]) โ€“

A SymbolicConstant specifying how the sketch is displayed. Possible values are:

  • STANDALONE: Indicates a new stand-alone sketch. The current viewport is

    cleared and is replaced by the stand-alone sketch. The view direction is set to -Z.

  • SUPERIMPOSE: Indicates that the sketch is superimposed on the current

    viewport. The view direction is changed to be perpendicular to the sketch plane. The change is effected smoothly as an animated sequence of many small viewing steps.

trimExtendCurve(curve1, point1, curve2, point2)[source]๏ƒ

This method trims or extends a specified ConstrainedSketchGeometry object (curve1) using another specified ConstrainedSketchGeometry object (curve2). curve2 is not affected by the operation. The location for the trim or extend is determined by the specified point values.

Parameters:
  • curve1 (str) โ€“ The ConstrainedSketchGeometry object specifying the object to be trimmed or extended.

  • point1 (tuple[float, float]) โ€“ A pair of Floats specifying the location on curve1 where trim or extend should be applied.

  • curve2 (str) โ€“ The ConstrainedSketchGeometry object specifying the object to which curve1 is trimmed or extended. curve2 is not trimmed or extended.

  • point2 (tuple[float, float]) โ€“ A pair of Floats specifying the location on curve2 near where curve1 should be trimmed or extended.

undo()[source]๏ƒ

This method undoes the effects of the last ConstrainedSketch object method.

unsetPrimaryObject()[source]๏ƒ

This method removes the ConstrainedSketch object from the current viewport, reversing the effects of the setPrimaryobject command.

If the option argument was set to SUPERIMPOSE, the viewport will be returned to the view orientation that was in place when the setPrimaryobject command was issued. If the option argument was set to STANDALONE, the viewport will be left empty.

writeAcisFile(fileName, version=None)[source]๏ƒ

This method exports the geometry of the sketch to a named file in ACIS format.

Parameters:
  • fileName (str) โ€“

    A String specifying the name of the file to which to write. The file nameโ€™s extension is used to determine whether a part or assembly is written. Use the file extension .asat for the assembly format.

    Changed in version 2018: Add description for thr file nameโ€™s extension.

  • version (Optional[float], default: None) โ€“ A Float specifying the ACIS version. For example, the Float 12.0 corresponds to ACIS Version 12.0. The default value is the current version of ACIS.

writeIgesFile(filename, flavor=Ellipsis)[source]๏ƒ

This method exports the geometry of the sketch to a named file in IGES format.

Parameters:
  • filename (str) โ€“ A String specifying the file name.

  • flavor (Literal[STANDARD, AUTOCAD, SOLIDWORKS, JAMA, MSBO], default: Ellipsis) โ€“ A SymbolicConstant specifying a particular flavor of IGES to export. Possible values are STANDARD, AUTOCAD, SOLIDWORKS, JAMA, and MSBO.

class ConstrainedSketchConstraintModel[source]๏ƒ

Bases: ConstrainedSketchBase

A ConstrainedSketch object contains the entities that are used to create a sketch. The objects include ConstrainedSketchGeometry objects contained in the ConstrainedSketchGeometry Repository, such as Line, Arc, and Spline. ConstrainedSketchVertex, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects are contained in their respective repositories.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name]

Member Details:

CoincidentConstraint(entity1, entity2)[source]๏ƒ

This method creates a coincident constraint. This constraint applies to two vertices, to a vertex and a ConstrainedSketchGeometry object, or to two ConstrainedSketchGeometry objects of the same type and constrains them to be coincident.

Note

This function can be accessed by:

mdb.models[name].sketches[name].CoincidentConstraint
Parameters:
  • entity1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the first object.

  • entity2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the second object.

Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

ConcentricConstraint(entity1, entity2)[source]๏ƒ

This method creates a concentric constraint. This constraint applies to any combination of circles, arcs, ellipses, and points and constrains them to be concentric. A concentric constraint implies that the center of ConstrainedSketchGeometry objects coincide.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConcentricConstraint
Parameters:
  • entity1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the first arc, circle, ellipse, or sketch vertex.

  • entity2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the second arc, circle, ellipse, or sketch vertex.

Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

EqualDistanceConstraint(entity1, entity2, midpoint)[source]๏ƒ

This method creates an equal distance constraint. This constraint can be applied between a midpoint ConstrainedSketchVertex object and any other two ConstrainedSketchVertex objects or between a midpoint ConstrainedSketchVertex object and two ConstrainedSketchGeometry objects that are lines. The equal distance constraint forces the midpoint vertex to remain at an equal distance from the two other vertices or lines.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EqualDistanceConstraint
Parameters:
  • entity1 (str) โ€“ AConstrainedSketchGeometry object specifying the first line or ConstrainedSketchVertex object.

  • entity2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the second line or ConstrainedSketchVertex object.

  • midpoint (Vertex) โ€“ A ConstrainedSketchVertex object specifying the vertex that will be positioned an equal distance from entity1 and entity2.

Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

EqualLengthConstraint(entity1, entity2)[source]๏ƒ

This method creates an equal length constraint. This constraint applies to lines and constrains them such that their lengths are equal.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EqualLengthConstraint
Parameters:
Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

EqualRadiusConstraint(entity1, entity2)[source]๏ƒ

This method creates an equal radius constraint. This constraint applies to circles and arcs and constrains them such that their radii are equal.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EqualRadiusConstraint
Parameters:
  • entity1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the first arc or circle.

  • entity2 (str) โ€“ A ConstrainedSketchGeometry specifying the second arc or circle.

Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

FixedConstraint(entity)[source]๏ƒ

This method creates a fixed constraint. This constraint applies to a ConstrainedSketchGeometry object or a ConstrainedSketchVertex object and constrains them to be fixed in space. Both the location and the shape of the sketch geometry is fixed.

Note

This function can be accessed by:

mdb.models[name].sketches[name].FixedConstraint
Parameters:

entity (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the item to fix in space.

Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

HorizontalConstraint(entity)[source]๏ƒ

This method creates a horizontal constraint. This constraint applies to a line and constrains it to be horizontal.

Note

This function can be accessed by:

mdb.models[name].sketches[name].HorizontalConstraint
Parameters:

entity (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the line to constrain.

Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

ParallelConstraint(entity1, entity2)[source]๏ƒ

This method creates a parallel constraint. This constraint applies to lines and constrains them to be parallel.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ParallelConstraint
Parameters:
Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

PerpendicularConstraint(entity1, entity2)[source]๏ƒ

This method creates a perpendicular constraint. This constraint applies to different types of ConstrainedSketchGeometry objects and constrains them to be perpendicular to each other.

Note

This function can be accessed by:

mdb.models[name].sketches[name].PerpendicularConstraint
Parameters:
Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

TangentConstraint(entity1, entity2)[source]๏ƒ

This method creates a tangent constraint. This constraint applies to different types of ConstrainedSketchGeometry objects and constrains them to remain tangential.

Note

This function can be accessed by:

mdb.models[name].sketches[name].TangentConstraint
Parameters:
Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

VerticalConstraint(entity)[source]๏ƒ

This method creates a vertical constraint. This constraint applies to a line and constrains it to be vertical.

Note

This function can be accessed by:

mdb.models[name].sketches[name].VerticalConstraint
Parameters:

entity (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the line to constrain.

Returns:

constraint โ€“ A ConstrainedSketchConstraint object

Return type:

ConstrainedSketchConstraint

class ConstrainedSketchDimensionModel[source]๏ƒ

Bases: ConstrainedSketchBase

A ConstrainedSketch object contains the entities that are used to create a sketch. The objects include ConstrainedSketchGeometry objects contained in the ConstrainedSketchGeometry Repository, such as Line, Arc, and Spline. ConstrainedSketchVertex, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects are contained in their respective repositories.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name]

Member Details:

AngularDimension(line1, line2, textPoint, value=None, reference=0)[source]๏ƒ

This method constructs a ConstrainedSketchDimension object between two ConstrainedSketchGeometry objects, with the given angle between them.

Note

This function can be accessed by:

mdb.models[name].sketches[name].AngularDimension
Parameters:
  • line1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the first line.

  • line2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the second line.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the angle between the two lines.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:

A ConstrainedSketchDimension object

Return type:

dimension

DistanceDimension(entity1, entity2, textPoint, value=None, reference=0)[source]๏ƒ

This method constructs a ConstrainedSketchDimension object between two ConstrainedSketchGeometry, or aConstrainedSketchVertex and ConstrainedSketchGeometry object. A distance dimension specifies the shortest distance between two entities.

Note

This function can be accessed by:

mdb.models[name].sketches[name].DistanceDimension
Parameters:
  • entity1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object or ConstrainedSketchGeometry object.

  • entity2 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object or ConstrainedSketchGeometry object.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the angle between the two lines.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:

A ConstrainedSketchDimension object

Return type:

dimension

HorizontalDimension(vertex1, vertex2, textPoint, value=None, reference=0)[source]๏ƒ

This method constructs a ConstrainedSketchDimension object between two vertices. A horizontal dimension indicates the horizontal distance along the X axis between two vertices.

Note

This function can be accessed by:

mdb.models[name].sketches[name].HorizontalDimension
Parameters:
  • vertex1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the first endpoint.

  • vertex2 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the second endpoint.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float distance between the two vertices.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the distance between the two vertices.

Returns:

A ConstrainedSketchDimension object

Return type:

dimension

ObliqueDimension(vertex1, vertex2, textPoint, value=None, reference=0)[source]๏ƒ

This method constructs a ConstrainedSketchDimension object between two vertices. An oblique dimension indicates the distance between two vertices.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ObliqueDimension
Parameters:
  • vertex1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the first endpoint.

  • vertex2 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the second endpoint.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the distance between the two ConstrainedSketchVertex objects.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the distance between the two vertices.

Returns:

A ConstrainedSketchDimension object

Return type:

dimension

RadialDimension(curve, textPoint, value=None, reference=0, majorRadius=None, minorRadius=None)[source]๏ƒ

This method constructs a ConstrainedSketchDimension object on a circular or elliptical arc. A radial dimension indicates the radius of an arc or circle or the major or minor radius of an ellipse.

Note

This function can be accessed by:

mdb.models[name].sketches[name].RadialDimension
Parameters:
  • curve (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the circular or elliptical arc.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the radius of the arc, circle or ellipse.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

  • majorRadius (Optional[float], default: None) โ€“ A Float specifying the major Radius if curve is an ellipse. This is mutually exclusive with value and minorRadius.

  • minorRadius (Optional[float], default: None) โ€“ A Float specifying the minor Radius if curve is an ellipse. This is mutually exclusive with value and majorRadius.

Returns:

A ConstrainedSketchDimension object

Return type:

dimension

VerticalDimension(vertex1, vertex2, textPoint, value=None, reference=0)[source]๏ƒ

This method constructs a ConstrainedSketchDimension between two vertices. A vertical dimension controls the vertical distance along the Y axis between two vertices.

Note

This function can be accessed by:

mdb.models[name].sketches[name].VerticalDimension
Parameters:
  • vertex1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the first endpoint.

  • vertex2 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the second endpoint.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the angle between the two lines.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:

A ConstrainedSketchDimension object

Return type:

dimension

class ConstrainedSketchGeometry[source]๏ƒ

Bases: object

The ConstrainedSketchGeometry object stores the geometry of a sketch, such as lines, circles, arcs, and construction lines.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].geometry[i]
mdb.models[name].sketches[name].geometry[i][i]

Member Details:

curveType: SymbolicConstant[source]๏ƒ

A SymbolicConstant specifying the geometry of the sketch entity. Possible values are ARC, CIRCLE, ELLIPSE, LINE, and SPLINE.

id: Optional[int] = None[source]๏ƒ

An Int specifying the index of the sketch entity in the ConstrainedSketchGeometryArray.

pointOn: Optional[float] = None[source]๏ƒ

A tuple of Floats specifying the X and*Y*-coordinates of a point located on the geometry.

type: SymbolicConstant[source]๏ƒ

A SymbolicConstant specifying the type of sketch entity. Possible values are REGULAR, REFERENCE, and CONSTRUCTION.

class ConstrainedSketchGeometryModel[source]๏ƒ

Bases: ConstrainedSketchBase

A ConstrainedSketch object contains the entities that are used to create a sketch. The objects include ConstrainedSketchGeometry objects contained in the ConstrainedSketchGeometry Repository, such as Line, Arc, and Spline. ConstrainedSketchVertex, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects are contained in their respective repositories.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name]

Member Details:

Arc3Points(point1, point2, point3)[source]๏ƒ

This method constructs an arc using a two endpoints and an intermediate third point on the arc.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Arc3Points
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint of the arc.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint of the arc.

  • point3 (Sequence[float]) โ€“ A pair of Floats specifying the third point on the arc.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

ArcByCenterEnds(center, point1, point2, direction=abaqusConstants.COUNTERCLOCKWISE)[source]๏ƒ

This method constructs an arc using a center point and two vertices. The Arc object is added to the geometry repository of the ConstrainedSketch object. The arc is created in a clockwise fashion from point1 to point2.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ArcByCenterEnds
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the arc.

  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint of the arc.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint of the arc.

  • direction (Literal[COUNTERCLOCKWISE, CLOCKWISE], default: COUNTERCLOCKWISE) โ€“ A SymbolicConstant specifying the direction of the arc. Possible values are CLOCKWISE and COUNTERCLOCKWISE.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

Raises:

Exception โ€“ If incompatible data are given, the second endpoint is ignored

ArcByStartEndTangent(point1, point2, vector)[source]๏ƒ

This method constructs an arc using two vertices. The Arc object is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ArcByStartEndTangent
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint of the arc.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint of the arc.

  • vector (tuple) โ€“ A sequence of two Floats specifying the start direction for constructing the arc.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

CircleByCenterPerimeter(center, point1)[source]๏ƒ

This method constructs a circle using a center point and a point on the perimeter. The circle is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].CircleByCenterPerimeter
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the circle.

  • point1 (Sequence[float]) โ€“ A pair of Floats specifying a point on the perimeter of the circle.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

ConstructionCircleByCenterPerimeter(center, point1)[source]๏ƒ

This method constructs a construction circle using a center point and a point on the perimeter. The circle is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConstructionCircleByCenterPerimeter
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the construction circle.

  • point1 (Sequence[float]) โ€“ A pair of Floats specifying a point on the perimeter of the construction circle.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

ConstructionLine(point1, point2)[source]๏ƒ

This method creates an oblique construction line that runs between two given points.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConstructionLine
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

EllipseByCenterPerimeter(center, axisPoint1, axisPoint2)[source]๏ƒ

This method constructs an ellipse using a center point, a major axis point, and a minor axis point. The ellipse is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EllipseByCenterPerimeter
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the ellipse.

  • axisPoint1 (Sequence[float]) โ€“ A pair of Floats specifying the major or minor axis point of the ellipse.

  • axisPoint2 (Sequence[float]) โ€“ A pair of Floats specifying the minor or major axis point of the ellipse.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

FilletByRadius(radius, curve1, nearPoint1, curve2, nearPoint2)[source]๏ƒ

This method constructs a fillet arc of a given radius between two curves. The fillet is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].FilletByRadius
Parameters:
  • radius (float) โ€“ A Float specifying the radius of the fillet arc. Possible values are Floats > 0.

  • curve1 (ConstrainedSketchGeometryModel) โ€“ A ConstrainedSketchGeometry object specifying the first curve.

  • nearPoint1 (Sequence[float]) โ€“ A pair of Floats specifying a point on the sketch near where the user wishes the fillet to intersect with curve1. This point does not need to be on*curve1*; it is used as a hint to draw the fillet.

  • curve2 (ConstrainedSketchGeometryModel) โ€“ A ConstrainedSketchGeometry object specifying the second curve.

  • nearPoint2 (Sequence[float]) โ€“ A pair of Floats specifying a point on the sketch near where the user wishes the fillet to intersect with curve2. This point does not need to be on curve2; it is used as a hint to draw the fillet.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

Raises:

Range Error โ€“ cannot construct the Fillet specified, If the radius given cannot be used to create a fillet between the two curves given.

Line(point1, point2)[source]๏ƒ

This method creates a line between two given points.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Line
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

Spline(points, constrainPoints=True)[source]๏ƒ

This method creates a spline curve running through a sequence of points.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Spline
Parameters:
  • points (tuple) โ€“ A sequence of pairs of Floats specifying the points through which the spline passes.

  • constrainPoints (Union[AbaqusBoolean, bool], default: True) โ€“ A Boolean that determines whether the points given are to constrained to always remain on the Spline. The default is True. For a large sequence of points, significant performance gains may be achieved by setting the value to False.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

Spot(point)[source]๏ƒ

This method creates a spot construction point located at the specified coordinates. The spot is added to the vertex repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Spot
Parameters:

point (Sequence[float]) โ€“ A pair of Floats specifying the coordinates of the spot construction point.

Returns:

geometry โ€“ A ConstrainedSketchGeometry object

Return type:

ConstrainedSketchGeometry

getPointAtDistance(point, distance, percentage=0)[source]๏ƒ

This method returns a point offset along the given ConstrainedSketchGeometry from the given end by a specified arc length distance or a percentage of the total length of the ConstrainedSketchGeometry object.

Parameters:
  • point (Sequence[float]) โ€“ A pair of Floats specifying the point from which the distance is to be measured.

  • distance (str) โ€“ A float specifying the arc length distance along the ConstrainedSketchGeometry from the point at which the required point is situated.

  • percentage (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean that specifies if the distance is an absolute distance or is a fraction relative to the length of the ConstrainedSketchGeometry object.

Returns:

points โ€“ A pair of floats representing the point along the edge

Return type:

Sequence[float]

getSize()[source]๏ƒ

This method returns the length of the given ConstrainedSketchGeometry object.

Returns:

length โ€“ The length of the given ConstrainedSketchGeometry

Return type:

int

getVertices()[source]๏ƒ

This method returns an list of ConstrainedSketchVertex objects which are a part of the given ConstrainedSketchGeometry object.

Returns:

vertices โ€“ A list of ConstrainedSketchVertex objects

Return type:

list[ConstrainedSketchVertex]

class ConstrainedSketchParameterModel[source]๏ƒ

Bases: ConstrainedSketchBase

A ConstrainedSketch object contains the entities that are used to create a sketch. The objects include ConstrainedSketchGeometry objects contained in the ConstrainedSketchGeometry Repository, such as Line, Arc, and Spline. ConstrainedSketchVertex, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects are contained in their respective repositories.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name]

Member Details:

ConstrainedSketchParameter(name, path='', expression='', previousParameter='')[source]๏ƒ

This method creates a parameter and optionally associates a dimension with this parameter.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConstrainedSketchParameter
Parameters:
  • name (str) โ€“ A String specifying the name of the ConstrainedSketchParameter object. No two parameters in the same ConstrainedSketch can have the same name.

  • path (str, default: '') โ€“ A String specifying the ConstrainedSketchDimension object with which this parameter is associated.

  • expression (str, default: '') โ€“ A String specifying the expression or value associated with the ConstrainedSketchParameter.

  • previousParameter (str, default: '') โ€“ A String specifying the name of the previous ConstrainedSketchParameter, if it exists. The previousParameter argument implies an order among the parameters. No two parameters can reference the same parameter as the previous parameter.

Returns:

parameter โ€“ A ConstrainedSketchParameter object

Return type:

ConstrainedSketchParameter

class ConstrainedSketchVertex[source]๏ƒ

Bases: object

The ConstrainedSketchVertex object stores the vertex position.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].vertices[i]
mdb.models[name].sketches[name].vertices[i][i]

Member Details:

Spot(point)[source]๏ƒ

This method creates a spot (construction point) located at the specified coordinates.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Spot
Parameters:

point (Sequence[float]) โ€“ A pair of Floats specifying the coordinates of the construction point.

Returns:

A ConstrainedSketchVertex object (None if the spot cannot be created).

Return type:

ConstrainedSketchVertex

coords: Optional[float] = None[source]๏ƒ

A tuple of Floats specifying the*X*-, Y, and Z coordinates of the sketch vertex.

class ConstrainedSketchVertexModel[source]๏ƒ

Bases: ConstrainedSketchBase

A ConstrainedSketch object contains the entities that are used to create a sketch. The objects include ConstrainedSketchGeometry objects contained in the ConstrainedSketchGeometry Repository, such as Line, Arc, and Spline. ConstrainedSketchVertex, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects are contained in their respective repositories.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name]

Member Details:

Spot(point)[source]๏ƒ

This method creates a spot (construction point) located at the specified coordinates.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Spot
Parameters:

point (Sequence[float]) โ€“ A pair of Floats specifying the coordinates of the construction point.

Returns:

vertex โ€“ A ConstrainedSketchVertex object (None if the spot cannot be created)

Return type:

ConstrainedSketchVertex

class ConstrainedSketchBase[source]๏ƒ

Bases: object

A ConstrainedSketch object contains the entities that are used to create a sketch. The objects include ConstrainedSketchGeometry objects contained in the ConstrainedSketchGeometry Repository, such as Line, Arc, and Spline. ConstrainedSketchVertex, ConstrainedSketchDimension, ConstrainedSketchConstraint, and ConstrainedSketchParameter objects are contained in their respective repositories.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name]

Member Details:

constraints: dict[str, ConstrainedSketchConstraint] = {}[source]๏ƒ

A repository of ConstrainedSketchConstraint objects.

dimensions: dict[str, ConstrainedSketchDimension] = {}[source]๏ƒ

A repository of ConstrainedSketchDimension objects.

geometry: ConstrainedSketchGeometryArray = [][source]๏ƒ

A ConstrainedSketchGeometryArray object specifying the sketch geometry, such as lines, arcs, circles, and splines.

imageOptions: ConstrainedSketchImageOptions = <abaqus.Sketcher.ConstrainedSketchOptions.ConstrainedSketchImageOptions.ConstrainedSketchImageOptions object>[source]๏ƒ

A ConstrainedSketchImageOptions object.

parameters: dict[str, ConstrainedSketchParameter] = {}[source]๏ƒ

A repository of ConstrainedSketchParameter objects specifying sketch parameters, which may be associated with dimensions.

sketchOptions: ConstrainedSketchOptions = <abaqus.Sketcher.ConstrainedSketchOptions.ConstrainedSketchOptions.ConstrainedSketchOptions object>[source]๏ƒ

A ConstrainedSketchOptions object specifying the sketch option settings.

vertices: ConstrainedSketchVertexArray = [][source]๏ƒ

A ConstrainedSketchVertexArray object.

class ConstrainedSketchConstraint[source]๏ƒ

Bases: object

The ConstrainedSketchConstraint object stores the constraints associated with a sketch.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].constraints[i]

Member Details:

class ConstrainedSketchDimension[source]๏ƒ

Bases: object

The ConstrainedSketchDimension object stores the dimensions associated with a sketch.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].dimensions[i]

Member Details:

class ConstrainedSketchGeometryArray(iterable=(), /)[source]๏ƒ

Bases: List[ConstrainedSketchGeometry]

The ConstrainedSketchGeometryArray is a sequence of ConstrainedSketchGeometry objects.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].geometry[i]

Member Details:

findAt(coordinates, printWarning=True)[source]๏ƒ

This method returns the ConstrainedSketchGeometry object located at the given coordinates.

Parameters:
  • coordinates (tuple[float, float]) โ€“ A sequence of Floats specifying the X and Y coordinates of the object to find.

  • printWarning (Union[AbaqusBoolean, bool], default: True) โ€“ A Boolean specifying whether a message is to be printed to the CLI if no entity is found at the specified location. The default value is True.

Returns:

A ConstrainedSketchGeometry object.

Return type:

ConstrainedSketchGeometry

class ConstrainedSketchImageOptions[source]๏ƒ

Bases: object

The ConstrainedSketchImageOptions object is used to store values and attributes associated with the background image for a particular sketch. The ConstrainedSketchImageOptions object has no constructor.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].imageOptions

Member Details:

setValues(imageName='', showImage=0, origin=(), xScale=1, yScale=1, translucency=1)[source]๏ƒ

This method modifies the ConstrainedSketchOptions object.

Parameters:
  • imageName (str, default: '') โ€“ A String specifying the name of the image. A list of valid image names is in the images repository in the session object.

  • showImage (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether an image should be displayed in the sketcher background. The default value is OFF.

  • origin (Sequence[float], default: ()) โ€“ A pair of Floats specifying the X and Y offsets in millimeters from the lower-left corner of the viewport. The default value is (0, 0).

  • xScale (float, default: 1) โ€“ A Float specifying the scale applied to the image width. The default value is 1.0.When xScale is negative, the image is mirrored about its y-axis but its position is not affected.

  • yScale (float, default: 1) โ€“ A Float specifying the scale applied to the image height. The default value is 1.0.When yScale is negative, the image is mirrored about its x-axis but its position is not affected.

  • translucency (float, default: 1) โ€“ A Float specifying the translucency factor to use when displaying the image. Possible values are 0.0 โ‰ค translucency โ‰ค 1.0 with 0.0 being invisible and 1.0 being opaque. The default value is 1.0.

Raises:

RangeError โ€“

class ConstrainedSketchOptions[source]๏ƒ

Bases: object

The ConstrainedSketchOptions object is used to store values and attributes associated with a particular sketch. The ConstrainedSketchOptions object has no constructor.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].sketchOptions

Member Details:

setValues(sheetSize=None, gridSpacing=None, grid=1, gridFrequency=1, dimensionTextHeight=12, decimalPlaces=None, constructionGeometry=1, gridSnap=1, preselection=1, sheetAuto=1, gridOrigin=(), gridAngle=0, viewStyle=abaqusConstants.REGULAR, addImpliedConstraints=1, maxCoplanarEntities=300, autoConstrainAngularTolerance=0, autoConstrainLinearTolerance=None, autoConstrainOptions=None, dragMethod=abaqusConstants.MINIMUM_MOVE, editMethod=abaqusConstants.STANDARD)[source]๏ƒ

This method modifies the ConstrainedSketchOptions object.

Parameters:
  • sheetSize (Optional[float], default: None) โ€“ A Float specifying the sheet size. Possible values are Floats > 0. The default value is the sheetSize specified with the Sketch method.

  • gridSpacing (Optional[float], default: None) โ€“ A Float specifying the spacing between gridlines. Possible values are Floats > 0. The default value is approximately 2.5% of sheetSize.

  • grid (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying whether the grid is shown. The default value is ON.

  • gridFrequency (int, default: 1) โ€“ An Int specifying how often gridlines are shown. Possible values are gridFrequency > 0. The default value is 1.

  • dimensionTextHeight (float, default: 12) โ€“ A Float specifying the height of the dimension text in points. Possible values are Floats > 0. The default value is 12.0.

  • decimalPlaces (Optional[int], default: None) โ€“ An Int specifying how many decimal places are shown in dimensions. Possible values are 0 โ‰ค decimalPlaces โ‰ค 6. The initial value depends on the value of sheetSize.

  • constructionGeometry (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying whether construction geometry is shown. The default value is ON.

  • gridSnap (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying whether the cursor snaps to the grid. The default value is ON.

  • preselection (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying whether geometry will be preselected. The default value is ON.

  • sheetAuto (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying if the sheet size and the grid spacing are automatically computed. The default value is ON.

  • gridOrigin (tuple, default: ()) โ€“ A sequence of Floats specifying the X - Y coordinates for the origin of the grid. The default value is (0, 0).

  • gridAngle (float, default: 0) โ€“ A Float specifying the angle of the grid relative to the computer screen. The default value is 0.0.

  • viewStyle (Literal[AXISYM, REGULAR], default: REGULAR) โ€“ A SymbolicConstant specifying the type of sketch displayed in the viewport. Possible values are REGULAR and AXISYM. The default value is REGULAR.

  • addImpliedConstraints (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying if implied constraints are added during sketching. The default value is ON.

  • maxCoplanarEntities (int, default: 300) โ€“ An Int specifying the maximum number of coplanar entities which should be automatically projected from the background, when a sketch based feature is created or edited. When this value is exceeded no entities are automatically projected and a warning issued. Possible values are maxCoplanarEntities > 0. The default value is 300.

  • autoConstrainAngularTolerance (float, default: 0) โ€“ A Float specifying the angular tolerance in degrees which is used to determine parallel and tangential conditions during the auto-constrain operation. For example any two lines which have an angle smaller than the given autoConstrainAngularTolerance will be assumed to be parallel, and a parallel constrain may be added during the auto-constrain operation. The default value is 0.01.

  • autoConstrainLinearTolerance (Optional[float], default: None) โ€“ A Float specifying the linear tolerance which is used to determine when two points or geometries are coincident during the auto-constrain operation. The default value is 10โปโถ.

  • autoConstrainOptions (Optional[Literal[PERPENDICULAR, EQUALRADIUS, IDENTICAL, TANGENT, PARALLEL, CONCENTRIC]], default: None) โ€“ A sequence of SymbolicConstants specifying which type of constraints may be added by the auto-constraint tool. Possible values are PARALLEL, PERPENDICULAR, IDENTICAL, TANGENT, CONCENTRIC, and EQUALRADIUS. The default value is (PARALLEL,, PERPENDICULAR,, IDENTICAL,, TANGENT,, CONCENTRIC,, EQUALRADIUS).

  • dragMethod (Literal[WEIGHTED, RELAXATION, MINIMUM_MOVE, STANDARD], default: MINIMUM_MOVE) โ€“ A SymbolicConstant specifying the constraint solving mode used by the sketcher during drag operation. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is MINIMUM_MOVE.

  • editMethod (Literal[WEIGHTED, RELAXATION, MINIMUM_MOVE, STANDARD], default: STANDARD) โ€“ A SymbolicConstant specifying the constraint solving mode used by the sketcher during regular sketch editing and adding new constraints and dimensions. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is STANDARD.

Raises:

RangeError โ€“

class ConstrainedSketchParameter[source]๏ƒ

Bases: object

The ConstrainedSketchParameter object stores the definition of a parameter in the sketch.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].parameters[i]

Member Details:

Parameter(name, path='', expression='', previousParameter='')[source]๏ƒ

This method creates a parameter and optionally associates a dimension with this parameter.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConstrainedSketchParameter
Parameters:
  • name (str) โ€“ A String specifying the name of the ConstrainedSketchParameter object. No two parameters in the same ConstrainedSketch can have the same name.

  • path (str, default: '') โ€“ A String specifying the ConstrainedSketchDimension object with which this parameter is associated.

  • expression (str, default: '') โ€“ A String specifying the expression or value associated with the ConstrainedSketchParameter.

  • previousParameter (str, default: '') โ€“ A String specifying the name of the previous ConstrainedSketchParameter, if it exists. The previousParameter argument implies an order among the parameters. No two parameters can reference the same parameter as the previous parameter.

Returns:

A ConstrainedSketchParameter object.

Return type:

ConstrainedSketchParameter

expression: str = ''[source]๏ƒ

A String specifying an expression or value associated with this ConstrainedSketchParameter.

name: str = ''[source]๏ƒ

A String specifying the name of the ConstrainedSketchParameter object.

path: str = ''[source]๏ƒ

A String specifying the path to the ConstrainedSketchDimension that depends on this ConstrainedSketchParameter.

previousParameter: str = ''[source]๏ƒ

A String specifying the name of the ConstrainedSketchParameter that appears before this one in the ordered list.

class ConstrainedSketchVertexArray(iterable=(), /)[source]๏ƒ

Bases: List[ConstrainedSketchVertex]

The ConstrainedSketchVertexArray is a sequence of ConstrainedSketchVertex objects.

Note

This object can be accessed by:

import sketch
mdb.models[name].sketches[name].vertices[i]

Member Details:

findAt(coordinates, printWarning=True)[source]๏ƒ

This method returns the ConstrainedSketchVertex located at the given coordinates.

Parameters:
  • coordinates (tuple[float, float]) โ€“ A sequence of Floats specifying the X and Y coordinates of the object to find.

  • printWarning (Union[AbaqusBoolean, bool], default: True) โ€“ A Boolean specifying whether a message is to be printed to the CLI if no entity is found at the specified location. The default value is True.

Returns:

A ConstrainedSketchVertex object.

Return type:

ConstrainedSketchVertex

class CoincidentConstraint(entity1, entity2)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a coincident constraint. This constraint applies to two vertices, to a vertex and a ConstrainedSketchGeometry object, or to two ConstrainedSketchGeometry objects of the same type and constrains them to be coincident.

Note

This function can be accessed by:

mdb.models[name].sketches[name].CoincidentConstraint
Parameters:
  • entity1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the first object.

  • entity2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the second object.

Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class ConcentricConstraint(entity1, entity2)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a concentric constraint. This constraint applies to any combination of circles, arcs, ellipses, and points and constrains them to be concentric. A concentric constraint implies that the center of ConstrainedSketchGeometry objects coincide.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConcentricConstraint
Parameters:
  • entity1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the first arc, circle, ellipse, or sketch vertex.

  • entity2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the second arc, circle, ellipse, or sketch vertex.

Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class EqualDistanceConstraint(entity1, entity2, midpoint)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates an equal distance constraint. This constraint can be applied between a midpoint ConstrainedSketchVertex object and any other two ConstrainedSketchVertex objects or between a midpoint ConstrainedSketchVertex object and two ConstrainedSketchGeometry objects that are lines. The equal distance constraint forces the midpoint vertex to remain at an equal distance from the two other vertices or lines.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EqualDistanceConstraint
Parameters:
  • entity1 (str) โ€“ AConstrainedSketchGeometry object specifying the first line or ConstrainedSketchVertex object.

  • entity2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the second line or ConstrainedSketchVertex object.

  • midpoint (Vertex) โ€“ A ConstrainedSketchVertex object specifying the vertex that will be positioned an equal distance from entity1 and entity2.

Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class EqualLengthConstraint(entity1, entity2)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates an equal length constraint. This constraint applies to lines and constrains them such that their lengths are equal.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EqualLengthConstraint
Parameters:
Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class EqualRadiusConstraint(entity1, entity2)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates an equal radius constraint. This constraint applies to circles and arcs and constrains them such that their radii are equal.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EqualRadiusConstraint
Parameters:
  • entity1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the first arc or circle.

  • entity2 (str) โ€“ A ConstrainedSketchGeometry specifying the second arc or circle.

Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class FixedConstraint(entity)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a fixed constraint. This constraint applies to a ConstrainedSketchGeometry object or a ConstrainedSketchVertex object and constrains them to be fixed in space. Both the location and the shape of the sketch geometry is fixed.

Note

This function can be accessed by:

mdb.models[name].sketches[name].FixedConstraint
Parameters:

entity (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object or a ConstrainedSketchVertex object specifying the item to fix in space.

Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class HorizontalConstraint(entity)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a horizontal constraint. This constraint applies to a line and constrains it to be horizontal.

Note

This function can be accessed by:

mdb.models[name].sketches[name].HorizontalConstraint
Parameters:

entity (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the line to constrain.

Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class ParallelConstraint(entity1, entity2)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a parallel constraint. This constraint applies to lines and constrains them to be parallel.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ParallelConstraint
Parameters:
Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class PerpendicularConstraint(entity1, entity2)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a perpendicular constraint. This constraint applies to different types of ConstrainedSketchGeometry objects and constrains them to be perpendicular to each other.

Note

This function can be accessed by:

mdb.models[name].sketches[name].PerpendicularConstraint
Parameters:
Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class TangentConstraint(entity1, entity2)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a tangent constraint. This constraint applies to different types of ConstrainedSketchGeometry objects and constrains them to remain tangential.

Note

This function can be accessed by:

mdb.models[name].sketches[name].TangentConstraint
Parameters:
Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class VerticalConstraint(entity)[source]๏ƒ

Bases: ConstrainedSketchConstraint

This method creates a vertical constraint. This constraint applies to a line and constrains it to be vertical.

Note

This function can be accessed by:

mdb.models[name].sketches[name].VerticalConstraint
Parameters:

entity (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the line to constrain.

Returns:

A ConstrainedSketchConstraint object.

Return type:

ConstrainedSketchConstraint

Member Details:

class AngularDimension(line1, line2, textPoint, value=None, reference=0)[source]๏ƒ

Bases: ConstrainedSketchDimension

This method constructs a ConstrainedSketchDimension object between two ConstrainedSketchGeometry objects, with the given angle between them.

Note

This function can be accessed by:

mdb.models[name].sketches[name].AngularDimension
Parameters:
  • line1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the first line.

  • line2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the second line.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the angle between the two lines.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:

A ConstrainedSketchDimension object (None if the dimension cannot be created).

Return type:

ConstrainedSketchDimension

Member Details:

class DistanceDimension(entity1, entity2, textPoint, value=None, reference=0)[source]๏ƒ

Bases: ConstrainedSketchDimension

This method constructs a ConstrainedSketchDimension object between two ConstrainedSketchGeometry, or aConstrainedSketchVertex and ConstrainedSketchGeometry object. A distance dimension specifies the shortest distance between two entities.

Note

This function can be accessed by:

mdb.models[name].sketches[name].DistanceDimension
Parameters:
  • entity1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object or ConstrainedSketchGeometry object.

  • entity2 (ConstrainedSketchVertex) โ€“

    A ConstrainedSketchVertex object or ConstrainedSketchGeometry object.

    Changed in version 2017: The vertex2 argument was renamed to entity2.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the angle between the two lines.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:

A ConstrainedSketchDimension object (None if the dimension cannot be created).

Return type:

ConstrainedSketchDimension

Member Details:

class HorizontalDimension(vertex1, vertex2, textPoint, value=None, reference=0)[source]๏ƒ

Bases: ConstrainedSketchDimension

This method constructs a ConstrainedSketchDimension object between two vertices. A horizontal dimension indicates the horizontal distance along the X axis between two vertices.

Note

This function can be accessed by:

mdb.models[name].sketches[name].HorizontalDimension
Parameters:
  • vertex1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the first endpoint.

  • vertex2 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the second endpoint.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float distance between the two vertices.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the distance between the two vertices.

Returns:

A ConstrainedSketchDimension object (None if the dimension cannot be created).

Return type:

ConstrainedSketchDimension

Member Details:

class ObliqueDimension(vertex1, vertex2, textPoint, value=None, reference=0)[source]๏ƒ

Bases: ConstrainedSketchDimension

This method constructs a ConstrainedSketchDimension object between two vertices. An oblique dimension indicates the distance between two vertices.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ObliqueDimension
Parameters:
  • vertex1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the first endpoint.

  • vertex2 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the second endpoint.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the distance between the two ConstrainedSketchVertex objects.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the distance between the two vertices.

Returns:

A ConstrainedSketchDimension object (None if the dimension cannot be created).

Return type:

ConstrainedSketchDimension

Member Details:

class RadialDimension(curve, textPoint, value=None, reference=0, majorRadius=None, minorRadius=None)[source]๏ƒ

Bases: ConstrainedSketchDimension

This method constructs a ConstrainedSketchDimension object on a circular or elliptical arc. A radial dimension indicates the radius of an arc or circle or the major or minor radius of an ellipse.

Note

This function can be accessed by:

mdb.models[name].sketches[name].RadialDimension
Parameters:
  • curve (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the circular or elliptical arc.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the radius of the arc, circle or ellipse.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

  • majorRadius (Optional[float], default: None) โ€“ A Float specifying the major Radius if curve is an ellipse. This is mutually exclusive with value and minorRadius.

  • minorRadius (Optional[float], default: None) โ€“ A Float specifying the minor Radius if curve is an ellipse. This is mutually exclusive with value and majorRadius.

Returns:

A ConstrainedSketchDimension object (None if the dimension cannot be created).

Return type:

ConstrainedSketchDimension

Member Details:

class VerticalDimension(vertex1, vertex2, textPoint, value=None, reference=0)[source]๏ƒ

Bases: ConstrainedSketchDimension

This method constructs a ConstrainedSketchDimension between two vertices. A vertical dimension controls the vertical distance along the Y axis between two vertices.

Note

This function can be accessed by:

mdb.models[name].sketches[name].VerticalDimension
Parameters:
  • vertex1 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the first endpoint.

  • vertex2 (ConstrainedSketchVertex) โ€“ A ConstrainedSketchVertex object specifying the second endpoint.

  • textPoint (Sequence[float]) โ€“ A pair of Floats specifying the location of the dimension text.

  • value (Optional[float], default: None) โ€“ A Float specifying the angle between the two lines.

  • reference (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean specifying whether the created dimension enforces the above value or if it simply measures the angle between two lines.

Returns:

A ConstrainedSketchDimension object (None if the dimension cannot be created).

Return type:

ConstrainedSketchDimension

Member Details:

class Arc3Points(point1, point2, point3)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method constructs an arc using a two endpoints and an intermediate third point on the arc.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Arc3Points
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint of the arc.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint of the arc.

  • point3 (Sequence[float]) โ€“ A pair of Floats specifying the third point on the arc.

Returns:

A ConstrainedSketchGeometry object (None if the arc cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class ArcByCenterEnds(center, point1, point2, direction=abaqusConstants.COUNTERCLOCKWISE)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method constructs an arc using a center point and two vertices. The Arc object is added to the geometry repository of the ConstrainedSketch object. The arc is created in a clockwise fashion from point1 to point2.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ArcByCenterEnds
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the arc.

  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint of the arc.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint of the arc.

  • direction (Literal[COUNTERCLOCKWISE, CLOCKWISE], default: COUNTERCLOCKWISE) โ€“

    A SymbolicConstant specifying the direction of the arc. Possible values are CLOCKWISE and COUNTERCLOCKWISE.

    New in version 2017: The direction argument was added.

Returns:

A ConstrainedSketchGeometry object (None if the arc cannot be created).

Return type:

ConstrainedSketchGeometry

Raises:

Exception โ€“ If incompatible data are given, the second endpoint is ignored.

Member Details:

class ArcByStartEndTangent(point1, point2, vector)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method constructs an arc using two vertices. The Arc object is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ArcByStartEndTangent
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint of the arc.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint of the arc.

  • vector (tuple) โ€“ A sequence of two Floats specifying the start direction for constructing the arc.

Returns:

A ConstrainedSketchGeometry object (None if the arc cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class CircleByCenterPerimeter(center, point1)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method constructs a circle using a center point and a point on the perimeter. The circle is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].CircleByCenterPerimeter
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the circle.

  • point1 (Sequence[float]) โ€“ A pair of Floats specifying a point on the perimeter of the circle.

Returns:

A ConstrainedSketchGeometry object (None if the circle cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class ConstructionCircleByCenterPerimeter(center, point1)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method constructs a construction circle using a center point and a point on the perimeter. The circle is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConstructionCircleByCenterPerimeter
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the construction circle.

  • point1 (Sequence[float]) โ€“ A pair of Floats specifying a point on the perimeter of the construction circle.

Returns:

A ConstrainedSketchGeometry object (None if the circle cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class ConstructionLine(point1, point2)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method creates an oblique construction line that runs between two given points.

Note

This function can be accessed by:

mdb.models[name].sketches[name].ConstructionLine
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint.

Returns:

A ConstrainedSketchGeometry object (None if the line cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class EllipseByCenterPerimeter(center, axisPoint1, axisPoint2)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method constructs an ellipse using a center point, a major axis point, and a minor axis point. The ellipse is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].EllipseByCenterPerimeter
Parameters:
  • center (Sequence[float]) โ€“ A pair of Floats specifying the center point of the ellipse.

  • axisPoint1 (Sequence[float]) โ€“ A pair of Floats specifying the major or minor axis point of the ellipse.

  • axisPoint2 (Sequence[float]) โ€“ A pair of Floats specifying the minor or major axis point of the ellipse.

Returns:

A ConstrainedSketchGeometry object (None if the ellipse cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class FilletByRadius(radius, curve1, nearPoint1, curve2, nearPoint2)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method constructs a fillet arc of a given radius between two curves. The fillet is added to the geometry repository of the ConstrainedSketch object.

Note

This function can be accessed by:

mdb.models[name].sketches[name].FilletByRadius
Parameters:
  • radius (float) โ€“ A Float specifying the radius of the fillet arc. Possible values are Floats > 0.

  • curve1 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the first curve.

  • nearPoint1 (Sequence[float]) โ€“ A pair of Floats specifying a point on the sketch near where the user wishes the fillet to intersect with curve1. This point does not need to be on*curve1*; it is used as a hint to draw the fillet.

  • curve2 (ConstrainedSketchGeometry) โ€“ A ConstrainedSketchGeometry object specifying the second curve.

  • nearPoint2 (Sequence[float]) โ€“ A pair of Floats specifying a point on the sketch near where the user wishes the fillet to intersect with curve2. This point does not need to be on curve2; it is used as a hint to draw the fillet.

Returns:

A ConstrainedSketchGeometry object (None if the fillet cannot be created).

Return type:

ConstrainedSketchGeometry

Raises:

Range Error โ€“ cannot construct the Fillet specified, If the radius given cannot be used to create a fillet between the two curves given.

Member Details:

class Line(point1, point2)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method creates a line between two given points.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Line
Parameters:
  • point1 (Sequence[float]) โ€“ A pair of Floats specifying the first endpoint.

  • point2 (Sequence[float]) โ€“ A pair of Floats specifying the second endpoint.

Returns:

A ConstrainedSketchGeometry object (None if the line cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class Spline(points, constrainPoints=True)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method creates a spline curve running through a sequence of points.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Spline
Parameters:
  • points (tuple) โ€“ A sequence of pairs of Floats specifying the points through which the spline passes.

  • constrainPoints (Union[AbaqusBoolean, bool], default: True) โ€“ A Boolean that determines whether the points given are to constrained to always remain on the __init__. The default is True. For a large sequence of points, significant performance gains may be achieved by setting the value to False.

Returns:

A ConstrainedSketchGeometry object (None if the spline cannot be created).

Return type:

ConstrainedSketchGeometry

Member Details:

class Spot(point)[source]๏ƒ

Bases: ConstrainedSketchVertex

This method creates a spot (construction point) located at the specified coordinates.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Spot
Parameters:

point (Sequence[float]) โ€“ A pair of Floats specifying the coordinates of the construction point.

Returns:

A ConstrainedSketchVertex object (None if the spot cannot be created).

Return type:

ConstrainedSketchVertex

Member Details:

class getPointAtDistance(point, distance, percentage=0)[source]๏ƒ

Bases: ConstrainedSketchGeometry

This method returns a point offset along the given ConstrainedSketchGeometry from the given end by a specified arc length distance or a percentage of the total length of the ConstrainedSketchGeometry object.

Parameters:
  • point (Sequence[float]) โ€“ A pair of Floats specifying the point from which the distance is to be measured.

  • distance (str) โ€“ A float specifying the arc length distance along the ConstrainedSketchGeometry from the point at which the required point is situated.

  • percentage (Union[AbaqusBoolean, bool], default: 0) โ€“ A Boolean that specifies if the distance is an absolute distance or is a fraction relative to the length of the ConstrainedSketchGeometry object.

Returns:

A pair of floats representing the point along the edge.

Return type:

Sequence[float]

Member Details:

class ConstrainedSketcherOptions[source]๏ƒ

Bases: object

The ConstrainedSketcherOptions object is used to store values and attributes which will be applied to all sketches used in the current session. The ConstrainedSketcherOptions object has no constructor.

Note

This object can be accessed by:

import sketch
session.sketcherOptions

Member Details:

setValues(constructionGeometry=1, gridSnap=1, preselection=1, addImpliedConstraints=1, maxCoplanarEntities=300, autoConstrainAngularTolerance=0, autoConstrainLinearTolerance=None, autoConstrainOptions=None, dragMethod=abaqusConstants.MINIMUM_MOVE, editMethod=abaqusConstants.STANDARD)[source]๏ƒ

This method modifies the ConstrainedSketchOptions object.

Parameters:
  • constructionGeometry (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying whether construction geometry is shown. The default value is ON.

  • gridSnap (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying whether the cursor snaps to the grid. The default value is ON.

  • preselection (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying whether geometry will be preselected. The default value is ON.

  • addImpliedConstraints (Union[AbaqusBoolean, bool], default: 1) โ€“ A Boolean specifying if implied constraints are added during sketching. The default value is ON.

  • maxCoplanarEntities (int, default: 300) โ€“ An Int specifying the maximum number of coplanar entities which should be automatically projected from the background, when a sketch based feature is created or edited. When this value is exceeded no entities are automatically projected and a warning issued. Possible values are maxCoplanarEntities > 0. The default value is 300.

  • autoConstrainAngularTolerance (float, default: 0) โ€“ A Float specifying the angular tolerance in degrees which is used to determine parallel and tangential conditions during the auto-constrain operation. For example any two lines which have an angle smaller than the given autoConstrainAngularTolerance will be assumed to be parallel, and a parallel constrain may be added during the auto-constrain operation. The default value is 0.01.

  • autoConstrainLinearTolerance (Optional[float], default: None) โ€“ A Float specifying the linear tolerance which is used to determine when two points or geometries are coincident during the auto-constrain operation. The default value is 10โปโถ.

  • autoConstrainOptions (Optional[Literal[PERPENDICULAR, EQUALRADIUS, IDENTICAL, TANGENT, PARALLEL, CONCENTRIC]], default: None) โ€“ A sequence of SymbolicConstants specifying which type of constraints may be added by the auto-constraint tool. Possible values are PARALLEL, PERPENDICULAR, IDENTICAL, TANGENT, CONCENTRIC, and EQUALRADIUS. The default value is (PARALLEL,, PERPENDICULAR,, IDENTICAL,, TANGENT,, CONCENTRIC,, EQUALRADIUS).

  • dragMethod (Literal[WEIGHTED, RELAXATION, MINIMUM_MOVE, STANDARD], default: MINIMUM_MOVE) โ€“ A SymbolicConstant specifying the constraint solving mode used by the sketcher during drag operation. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is MINIMUM_MOVE.

  • editMethod (Literal[WEIGHTED, RELAXATION, MINIMUM_MOVE, STANDARD], default: STANDARD) โ€“ A SymbolicConstant specifying the constraint solving mode used by the sketcher during regular sketch editing and adding new constraints and dimensions. Possible values are MINIMUM_MOVE, STANDARD, WEIGHTED, and RELAXATION. The default value is STANDARD.

Raises:

RangeError โ€“

class Parameter(name, path='', expression='', previous='')[source]๏ƒ

Bases: ConstrainedSketchParameter

This method creates a parameter and optionally associates a dimension with this parameter.

Note

This function can be accessed by:

mdb.models[name].sketches[name].Parameter
Parameters:
  • name (str) โ€“ A String specifying the name of the ConstrainedSketch object. No two parameters in the same ConstrainedSketch can have the same name.

  • path (str, default: '') โ€“ A String specifying the ConstrainedSketchDimension object with which this parameter is associated.

  • expression (str, default: '') โ€“ A String specifying the expression or value associated with the ConstrainedSketch.

  • previous (str, default: '') โ€“ A String specifying the name of the previous ConstrainedSketch, if it exists. The previous argument implies an order among the parameters. No two parameters can reference the same parameter as the previous parameter.

Returns:

sketch โ€“ A ConstrainedSketch object.

Return type:

ConstrainedSketch

Member Details: